#!/usr/bin/env node

var connect = require("connect");
var http = require("http");
var querystring = require("querystring");
var parse = require('url').parse;

var thrift = require('simplegeo-thrift'),
//    ttransport = require("thrift/lib/thrift/transport.js"),
    //ttransport = require('thrift/transport');
    IndexService = require('./gen-nodejs/IndexService'),
    ttypes = require('./gen-nodejs/index_types');

//var connection = thrift.createConnection("localhost", 9090, {transport: ttransport.TBufferedTransport}),
var connection = thrift.createConnection("localhost", 9090),
//var connection = thrift.createConnection("node2.p.efg", 9090),
    client = thrift.createClient(IndexService, connection);

function indexLookup(req, res, next) {
    var p = querystring.parse(parse(req.url).query)
    
    client.indexLookup(p.id, p.query, p.mdformat, p.layout, function(err, response) {
        if(err) 
            res.end(err.why);
        else
            res.end(response);
    });
}

function getNumberOfElements(req, res, next) {
    client.getNumberOfElements("id", function(err, response) {
        res.end(response);
    });
};

function getResult(req, res, next) {
    client.getNumberResult("id", 1, 20, function(err, response) {
        res.end(response);
    });
};

connect(
    connect.router(function(app) {
        app.get('/IndexService/indexLookup',  indexLookup);
        app.get('/resultSet/getNumberOfElements', getNumberOfElements);
        app.get('/resultSet/getResult', getResult);

        app.get('/:context/services/IndexService/indexLookup',  indexLookup);
        app.get('/:context/services/resultSet/getNumberOfElements', getNumberOfElements);
        app.get('/:context/services/resultSet/getResult', getResult);

    })
).listen(3000);
